>From bcb58d845de384fb007222348a2ef1056488a648 Mon Sep 17 00:00:00 2001
From: Sergio Ammirata <sergio@ammirata.net>
Date: Tue, 27 Nov 2018 08:15:28 -0500
Subject: [PATCH 3/3] RIST access and access_output: check the return value of
 getsockopt

---
 modules/access/rist.h | 36 ++++++++++++++++++++----------------
 1 file changed, 20 insertions(+), 16 deletions(-)

diff --git a/modules/access/rist.h b/modules/access/rist.h
index 256c1fc..574bc40 100644
--- a/modules/access/rist.h
+++ b/modules/access/rist.h
@@ -278,15 +278,17 @@ static inline ssize_t rist_WriteTo_i11e(int fd, const void *buf, size_t len,
         && net_errno != ENOBUFS && net_errno != ENOMEM )
     {
         int type;
-        getsockopt( fd, SOL_SOCKET, SO_TYPE,
-                    &type, &(socklen_t){ sizeof(type) });
-        if( type == SOCK_DGRAM )
+        if (!getsockopt( fd, SOL_SOCKET, SO_TYPE,
+                    &type, &(socklen_t){ sizeof(type) }))
         {
-            /* ICMP soft error: ignore and retry */
-            if (slen == 0)
-                r = vlc_send_i11e( fd, buf, len, 0 );
-            else
-                r = vlc_sendto_i11e( fd, buf, len, 0, peer, slen );
+            if( type == SOCK_DGRAM )
+            {
+                /* ICMP soft error: ignore and retry */
+                if (slen == 0)
+                    r = vlc_send_i11e( fd, buf, len, 0 );
+                else
+                    r = vlc_sendto_i11e( fd, buf, len, 0, peer, slen );
+            }
         }
     }
     return r;
@@ -315,15 +317,17 @@ static inline ssize_t rist_WriteTo(int fd, const void *buf, size_t len, const st
         && net_errno != ENOBUFS && net_errno != ENOMEM )
     {
         int type;
-        getsockopt( fd, SOL_SOCKET, SO_TYPE,
-                    &type, &(socklen_t){ sizeof(type) });
-        if( type == SOCK_DGRAM )
+        if (!getsockopt( fd, SOL_SOCKET, SO_TYPE,
+                    &type, &(socklen_t){ sizeof(type) }))
         {
-            /* ICMP soft error: ignore and retry */
-            if (slen == 0)
-                r = send( fd, buf, len, 0 );
-            else
-                r = sendto( fd, buf, len, 0, peer, slen );
+            if( type == SOCK_DGRAM )
+            {
+                /* ICMP soft error: ignore and retry */
+                if (slen == 0)
+                    r = send( fd, buf, len, 0 );
+                else
+                    r = sendto( fd, buf, len, 0, peer, slen );
+            }
         }
     }
     return r;
-- 
2.7.4

